--
-- moduliner script by @poc@lypse
-- Edited to fit Samson PG Drill 
-- **** Timbertaz *******


-- 	edit by gotchTOM
--	@date 01-Dez-2010 
-- 	add inputbindings, new infoPanel, rotationMax5Delay, rotationMax6Delay, cultivatorDelay, drumNodeRotaryDelay, sowingDelay, drivemark + drivemarkDelay, markwheels -> updatePloughArea or updateCultivatorArea   

kdrill = {};

function kdrill.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Sprayer, specializations);
end;

function kdrill:load(xmlFile)

	self.rotationMax5Delay = 2000;
	self.rotationMax6Delay = 2000;
	self.cultivatorDelay = 1000;
	self.drumNodeRotaryDelay = 1000;
	self.sowingDelay = 1500;
	
  self.aiTerrainDetailChannel1 = g_currentMission.ploughChannel;
self.aiTerrainDetailChannel2 = g_currentMission.sowingChannel;
	self.safeMode = true;
       self.AIon = false;

	
   



      local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    self.cuttingAreas = {}
    for i=1, numCuttingAreas do
        self.cuttingAreas[i] = {};
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea" .. "%d", i); 
        self.cuttingAreas[i].start = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, areanamei .. "#startIndex"));
        self.cuttingAreas[i].width = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, areanamei .. "#widthIndex"));
        self.cuttingAreas[i].height = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, areanamei .. "#heightIndex"));
    end;

   
	

    ----- Relevage barre de semis

    local rotationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart#index"));
    if rotationPartNode ~= nil then
        self.rotationPart = {};
        self.rotationPart.node = rotationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#minRot"));
        self.rotationPart.minRot = {};
        self.rotationPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#maxRot"));
        self.rotationPart.maxRot = {};
        self.rotationPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#rotTime"), 2)*1000;
        self.rotationPart.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#touchRotLimit"), 10));
    end;

    local translationPartNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart1#index"));
    if translationPartNode1 ~= nil then
        self.translationPart1 = {};
        self.translationPart1.node = translationPartNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart1#minTrans"));
        self.translationPart1.minTrans = {};
        self.translationPart1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart1.minTrans[3] = Utils.getNoNil(z, 0);
	print ("load doTranslate and transMax")
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart1#maxTrans"));
        self.translationPart1.maxTrans = {};
        self.translationPart1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart1#transTime"), 2)*1000;
        self.translationPart1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart1#touchTransLimit"), 10);
        self.rotationPart.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart1#pivotverin"));
    end;

   local rotationPartNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart1#index"));
    if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart1#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#rotTime"), 2)*1000;
        self.rotationPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart1#touchRotLimit"), 10));
        self.rotationPart1.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart1#pivotverin"));        
    end;

        local rotationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
    if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
        self.rotationPart2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart2#pivotverin"));        
    end;

      local rotationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart3#index"));
    if rotationPartNode3 ~= nil then
        self.rotationPart3 = {};
        self.rotationPart3.node = rotationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#minRot"));
        self.rotationPart3.minRot = {};
        self.rotationPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#maxRot"));
        self.rotationPart3.maxRot = {};
        self.rotationPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#rotTime"), 2)*1000;
        self.rotationPart3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#touchRotLimit"), 10));
      end;

        local rotationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart4#index"));
    if rotationPartNode4 ~= nil then
        self.rotationPart4 = {};
        self.rotationPart4.node = rotationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#minRot"));
        self.rotationPart4.minRot = {};
        self.rotationPart4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#maxRot"));
        self.rotationPart4.maxRot = {};
        self.rotationPart4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#rotTime"), 2)*1000;
        self.rotationPart4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#touchRotLimit"), 10));
end;
       local rotationPartNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart5#index"));
    if rotationPartNode5 ~= nil then
        self.rotationPart5 = {};
        self.rotationPart5.node = rotationPartNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart5#minRot"));
        self.rotationPart5.minRot = {};
        self.rotationPart5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart5#maxRot"));
        self.rotationPart5.maxRot = {};
        self.rotationPart5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart5#rotTime"), 2)*1000;
        self.rotationPart5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart5#touchRotLimit"), 10));
 end;

    local rotationPartNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart6#index"));
    if rotationPartNode6 ~= nil then
        self.rotationPart6 = {};
        self.rotationPart6.node = rotationPartNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#minRot"));
        self.rotationPart6.minRot = {};
        self.rotationPart6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#maxRot"));
        self.rotationPart6.maxRot = {};
        self.rotationPart6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#rotTime"), 2)*1000;
        self.rotationPart6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#touchRotLimit"), 10));
 end;   
   self.verin = {};
	self.verin.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin#indexverin"));
	self.verin.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin#indextige"));
	self.verin.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin.tige);
    local bx, by, bz = getWorldTranslation(self.verin.translationtige);
    self.verin.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz); 

    self.verin1 = {};
	self.verin1.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indexverin"));
	self.verin1.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indextige"));
	self.verin1.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin1.tige);
    local bx, by, bz = getWorldTranslation(self.verin1.translationtige);
    self.verin1.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

    self.verin2 = {};
	self.verin2.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indexverin"));
	self.verin2.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indextige"));
	self.verin2.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin2.tige);
    local bx, by, bz = getWorldTranslation(self.verin2.translationtige);
	self.verin2.tigeDistance = Utils.vector3Length(bx-ax, by-ay, bz-az);
--    self.verin2.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

  ----- depliage rotative

  local rotationPartNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartRight#index"));
    if rotationPartNodeRight ~= nil then
        self.rotationPartRight = {};
        self.rotationPartRight.node = rotationPartNodeRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#minRot"));
        self.rotationPartRight.minRot = {};
        self.rotationPartRight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartRight#maxRot"));
        self.rotationPartRight.maxRot = {};
        self.rotationPartRight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartRight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartRight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartRight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#rotTime"), 2)*1000;
        self.rotationPartRight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartRight#touchRotLimit"), 10));
    end;
	
	
	local rotationPartNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartLeft#index"));
    if rotationPartNodeLeft ~= nil then
        self.rotationPartLeft = {};
        self.rotationPartLeft.node = rotationPartNodeLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#minRot"));
        self.rotationPartLeft.minRot = {};
        self.rotationPartLeft.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeft#maxRot"));
        self.rotationPartLeft.maxRot = {};
        self.rotationPartLeft.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeft.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeft.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartLeft.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#rotTime"), 2)*1000;
        self.rotationPartLeft.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeft#touchRotLimit"), 10));
    end;

     local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);
	print ("load doTranslate and transMax")
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;

    self.drumNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index"));
	self.drumNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drum#index2"));
	self.drumNodeRotary = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index"));
	self.drumNodeRotary2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index2"));
	self.drumNodeRotary3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index3"));
	self.drumNodeRotary4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index4"));
	self.drumNodeRotary5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index5"));
	self.drumNodeRotary6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index6"));
	self.drumNodeRotary7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index7"));
	self.drumNodeRotary8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index8"));
	self.drumNodeRotary9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index9"));
	self.drumNodeRotary10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index10"));
	self.drumNodeRotary11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index11"));
	self.drumNodeRotary12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotary#index12"));
    self.drumRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.drum#rotationScale"), 1);
	self.drumRotationScale2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.rotary#rotationScale"), 1);
 
	
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory);
        self.workSound = createSample("workSound");
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 0); 
        self.workSoundEnabled = false;       
    end;

            self.workSoundEnabled = false;
	

  
    
   
	self.time = 0;
	self.lastSoundSpeed = 0;        
        self.tramline = false;
       
        self.rotationMax5 = false;
	self.rotationMax6 = false;    
	
	
       
      

end;

function kdrill:delete()   

end;

function kdrill:mouseEvent(posX, posY, isDown, isUp, button)    
end;

function kdrill:keyEvent(unicode, sym, modifier, isDown)  



	if isDown and sym == Input.KEY_x  then
		self.rotationMaxLeft = not self.rotationMaxLeft;
		self.rotationMaxRight = not self.rotationMaxRight;  
		self.rotationMax1 = not self.rotationMax1;
		self.rotationMax2 = not self.rotationMax2;  
	end;
if isDown and sym == Input.KEY_z  then
		self.translation2Max = not self.translation2Max;  
		self.rotationMax = not self.rotationMax;
		self.translation1Max = not self.translation1Max;   
	end;
      if isDown and sym == Input.KEY_k  then
		self.marche = not self.marche; 
	
	end;
	if isDown and sym == Input.KEY_m then
		self.safeMode = not self.safeMode ;

	end;
     
end;

function kdrill:update(dt)
 
	self.time = self.time + dt;
          if self.attacherVehicle then
	
if self.attacherVehicle.isAITractorActivated ~= nil then
			self.AIon = self.attacherVehicle.isAITractorActivated;
			 end;
		end; 
		
		   if  self.AIon then
		   self.attacherVehicle.aiTurnNoBackward = true;
                   self.waitForTurnTime = 0;
                   stopSample(self.workSound, 0, 1.6, 0);
                   self.workSoundRunning = false;
		if self.attacherVehicle.turnStage == 5 then
			setTranslation(self.aiBackMarker, 0, 0, 0);
		else
			setTranslation(self.aiBackMarker, 0, 0, -4);
		end;
		    end;
			
	if self.rotationMax3 then
		self.rotationMax6Delay = self.rotationMax6Delay - dt;
		if self.rotationMax6Delay < 0 then
			self.rotationMax6Delay = 0;
		end;
		if 	self.rotationMax6Delay <= 1000 then
		self.rotationMax5 = false;
		self.rotationMax6 = true;
		end;
	end;

	if self.rotationMax4 then
		self.rotationMax5Delay = self.rotationMax5Delay - dt;
		if self.rotationMax5Delay < 0 then
			self.rotationMax5Delay = 0;
		end;
		if 	self.rotationMax5Delay <= 1000 then
		self.rotationMax5 = true;
		self.rotationMax6 = false;
		end;
	end;	
 
     
  
    if self.rotationPart ~= nil then
      local x, y, z = getRotation(self.rotationPart.node);
      local rot = {x,y,z};                                             		
      local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart.maxRot, self.rotationPart.minRot, 3, self.rotationPart.rotTime, dt, not self.rotationMax);
      setRotation(self.rotationPart.node, unpack(newRot));
    end;
   
     if self.rotationPart3 ~= nil then
          local x, y, z = getRotation(self.rotationPart3.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart3.maxRot, self.rotationPart3.minRot, 3, self.rotationPart3.rotTime, dt, not self.rotationMax3);
          setRotation(self.rotationPart3.node, unpack(newRot));
    end;

    if self.rotationPart4 ~= nil then
          local x, y, z = getRotation(self.rotationPart4.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart4.maxRot, self.rotationPart4.minRot, 3, self.rotationPart4.rotTime, dt, not self.rotationMax4);
          setRotation(self.rotationPart4.node, unpack(newRot));
    end;

    if self.rotationPart5 ~= nil then
          local x, y, z = getRotation(self.rotationPart5.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart5.maxRot, self.rotationPart5.minRot, 3, self.rotationPart5.rotTime, dt, not self.rotationMax5);
          setRotation(self.rotationPart5.node, unpack(newRot));
    end;
  
    if self.rotationPart6 ~= nil then
          local x, y, z = getRotation(self.rotationPart6.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart6.maxRot, self.rotationPart6.minRot, 3, self.rotationPart6.rotTime, dt, not self.rotationMax6);
          setRotation(self.rotationPart6.node, unpack(newRot));
    end;
   
    if self.translationPart1 ~= nil then
        local x, y, z = getTranslation(self.translationPart1.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart1.maxTrans, self.translationPart1.minTrans, 3, self.translationPart1.transTime, dt, not self.translation1Max);
        setTranslation(self.translationPart1.node, unpack(newTrans));
        
    end;

     if self.verin ~= nil and self.rotationPart ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin.node);
		local bx, by, bz = getWorldTranslation(self.rotationPart.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin.node, x, y, z, 0, 1, 0);
		if self.verin.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin.tige, 0, (distance-self.verin.tigeDistance), 0);
		end;
	end;
 
     if self.verin1 ~= nil and self.rotationPart1 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin1.node);
		local bx, by, bz = getWorldTranslation(self.rotationPart1.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin1.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin1.node, x, y, z, 0, 1, 0);
		if self.verin1.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin1.tige, 0, (distance-self.verin1.tigeDistance), 0);
		end;
	end;

    if self.verin2 ~= nil and self.rotationPart2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin2.node);
		local bx, by, bz = getWorldTranslation(self.rotationPart2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin2.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin2.node, x, y, z, 0, 1, 0);
		if self.verin2.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin2.tige, 0, (distance-self.verin2.tigeDistance), 0);
		end;
	end;
    
	if self.rotationPartRight ~= nil then
        local x, y, z = getRotation(self.rotationPartRight.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartRight.maxRot, self.rotationPartRight.minRot, 3, self.rotationPartRight.rotTime, dt, not self.rotationMaxRight);
        setRotation(self.rotationPartRight.node, unpack(newRot));
    end;

    if self.rotationPartLeft ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartLeft.maxRot, self.rotationPartLeft.minRot, 3, self.rotationPartLeft.rotTime, dt, not self.rotationMaxLeft);
        setRotation(self.rotationPartLeft.node, unpack(newRot));
    end;

   if self.rotationPart1 ~= nil then
          local x, y, z = getRotation(self.rotationPart1.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime, dt, not self.rotationMax1);
          setRotation(self.rotationPart1.node, unpack(newRot));
    end;

     if self.rotationPart2 ~= nil then
          local x, y, z = getRotation(self.rotationPart2.node);
          local rot = {x,y,z};
          local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime, dt, not self.rotationMax2);
          setRotation(self.rotationPart2.node, unpack(newRot));
    end;


   self.isExpandedRight = false;
    if self.rotationPartRight ~= nil then
        local x, y, z = getRotation(self.rotationPartRight.node);
        local maxRot = self.rotationPartRight.maxRot;
        local eps = self.rotationPartRight.touchRotLimit;

        if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
            self.isExpandedRight = true;
        end;
    end;
	
	self.isExpandedLeft = false;
    if self.rotationPartLeft ~= nil then
        local x, y, z = getRotation(self.rotationPartLeft.node);
        local maxRot = self.rotationPartLeft.maxRot;
        local eps = self.rotationPartLeft.touchRotLimit;

        if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
            self.isExpandedLeft = true;
        end;
    end;

   self.isExpandedbarreRight = false;
    if self.rotationPart1 ~= nil then
        local x, y, z = getRotation(self.rotationPart1.node);
        local maxRot = self.rotationPart1.maxRot;
        local eps = self.rotationPart1.touchRotLimit;

        if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
            self.isExpandedbarreRight = true;
        end;
    end

   self.isExpandedbarreLeft = false;
    if self.rotationPart2 ~= nil then
        local x, y, z = getRotation(self.rotationPart2.node);
        local maxRot = self.rotationPart2.maxRot;
        local eps = self.rotationPart2.touchRotLimit;

        if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
            self.isExpandedbarreLeft = true;
        end;
    end;

   if self.translationPart2 ~= nil then
        local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translation2Max);
        setTranslation(self.translationPart2.node, unpack(newTrans));
    end;


    if self.isExpandedLeft and self.isExpandedRight and self.marche and self.translation2Max then
		self.cultivatorDelay = self.cultivatorDelay - dt;
		if self.cultivatorDelay <= 0 then
			self.cultivatorDelay = 0;
		end;
		if self.cultivatorDelay == 0 then
			for i=1, table.getn(self.cuttingAreas) do
				local x,y,z = getWorldTranslation(self.cuttingAreas[i].start);
				local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[i].width);
				local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[i].height);
				
                    if  i==1 or i==2 then
                    if self.safeMode then
                     kdrill.updateSafeArea(x, z, x1, z1, x2, z2)
                        else
						Utils.updateCultivatorArea(x, z, x1, z1, x2, z2);				                                 		
                    end;
				end;
			end;
		end;
	else
		self.cultivatorDelay = 1000;
    end;
   	
		 if self.marche then
		 playSample(self.workSound, 0, 1, 0);
			setSamplePitch(self.workSound, self.workSoundPitchOffset);
			self.workSoundEnabled = true;


		
		 
			if self.drumNodeRotary ~= nil then
				rotate(self.drumNodeRotary, self.drumRotationScale2 * 0.04 +dt  * 3, 0, 0);
			end;
			if self.drumNodeRotary2 ~= nil then
				rotate(self.drumNodeRotary2, self.drumRotationScale2 * 0.04 +dt  * 3, 0, 0);
			end;
			if self.drumNodeRotary3 ~= nil then
				rotate(self.drumNodeRotary3, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary4 ~= nil then
				rotate(self.drumNodeRotary4, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary5 ~= nil then
				rotate(self.drumNodeRotary5, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary6 ~= nil then
				rotate(self.drumNodeRotary6, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary7 ~= nil then
				rotate(self.drumNodeRotary7, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary8 ~= nil then
				rotate(self.drumNodeRotary8, self.drumRotationScale2 * 0.04 +dt  * 3, 0, 0);
			end;
			if self.drumNodeRotary9 ~= nil then
				rotate(self.drumNodeRotary9, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary10 ~= nil then
				rotate(self.drumNodeRotary10, self.drumRotationScale2 * 0.04 +dt   * 3, 0, 0);
			end;
			if self.drumNodeRotary11 ~= nil then
				rotate(self.drumNodeRotary11, self.drumRotationScale2 * 0.04 +dt  * 3, 0, 0);
			end;
			if self.drumNodeRotary12 ~= nil then
				rotate(self.drumNodeRotary12, self.drumRotationScale2 * 0.04 +dt  * 3, 0, 0);
			end;
	end;
			
	if not self.marche then
                stopSample(self.workSound);
		         self.workSoundEnabled = false;
			end;
			
			
			

end;
function kdrill:draw()  

if self.safeMode then
		g_currentMission:addExtraPrintText("M:Drill Safe Mode On");
	else
		g_currentMission:addExtraPrintText("M:Drill Safe Mode Off");
	end;
	

			
end; 


function kdrill:onAttach()


end;

function kdrill:aiLower()

self.safeMode =true;
end;

function kdrill:aiRaise()
	
self.safeMode = true;
end;


  kdrill.updateSafeArea = function(l_18_0, l_18_1, l_18_2, l_18_3, l_18_4, l_18_5)
  local cultiId = g_currentMission.cultivatorChannel
  local sowingId = g_currentMission.sowingChannel
  local detailId = g_currentMission.terrainDetailId
  local ploughId = g_currentMission.ploughChannel
  local sprayId = g_currentMission.sprayChannel
  local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(detailId, l_18_0, l_18_1, l_18_2, l_18_3, l_18_4, l_18_5)
  Utils.updateDestroyCommonArea(l_18_0, l_18_1, l_18_2, l_18_3, l_18_4, l_18_5)
  setDensityMaskedParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, cultiId, 1, detailId, sowingId, 1, 1)
  setDensityMaskedParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, cultiId, 1, detailId, ploughId, 1, 1)
  setDensityParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, sowingId, 1, 0)
  setDensityParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, ploughId, 1, 0)
  setDensityParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, sprayId, 1, 0)
end

function kdrill:onDetach()
       

      self.workSoundEnabled = false;  	
       
end;

